/*****
 *	Film.h
 *
 *	Declare globali per SAClient. e XPClient.
 *	 Com&Media, 1994
 *
 *	27/8/94		Prima stesura (Fabio Barbieri)
 *
 ****/
#define _H_Film


/*****	Include locali			*****/
#if MEMTRACK
#include "MemTrack.h"
#endif
#include <Types.h>

/*****	Define valori			*****/
#define kVersioneCorrente	1

#define	kQueryLength		1024
#define	kStringLength		256
#define kFieldLength		30

#define kCodBaseCampiAgg	100

enum {
	kOrdinaleTabella = 0, kCodice, kTitolo, kCodTitolo, kTitoloOrig, kSottotitolo,
	kCodSottotitolo, kTipo, kNazione, kAnnoProd, kAnnoDistr, kRegia, kAiutoRegia,
	kFonteSogg, kSoggetto, kScenegg, kDialoghi, kMontaggio, kOperatore, kFotografia,
	kEffSpeciali, kTrucco, kScenografia, kCostumi, kMusica, kCanzoni, kSuono, kTecnSuono,
	kVoceNarrante, kDirDoppiaggio, kDurata, kFormato, kColore, kProduttore, kProduzione,
	kProdEsecutivo, kProdAssociato, kDirProduzione, kCast, kTrama, kDivieti, kPremi,
	kNote, kGenere, kSottogenere, kGiudizio, kTramaSC, kTramaBreveSC, kRedattore,
	kUserID, kDataIns, kPuntata,
	kStatoControllo, kCodAzione, kTestata, 
	kIdxTitolo, kIdxTitoloOrig, kIdxNazione, kIdxPersone, kIdxColore, kIdxFormato,
	kIdxGenere, kIdxSuono, kIdxTipo, kIdxSottotitolo,
	kAltreInfo = kCodBaseCampiAgg, kOra, kCiclo, kIndicatori, kPrimaVis, kCommento,
	kSottotitolato
	};		// codici campi

#define kUltimoCampo		kTestata
#define kUltimoIndice		kIdxGenere

#define kNoPuntata			0

#define kTabCodiciBase		200
enum {
	kCodFilm = kTabCodiciBase, kChiave, kCodNazione, kCodColore, kCodGenere,
	kElencoCodFilm
	};		// codici campi aggiuntivi
	
#define kSignRegia			"REGI"
#define kSignAiutoRegia		"AREG"
#define kSignSoggetto		"SOGG"
#define kSignScenegg		"SCEN"
#define kSignDialoghi		"DIAL"
#define kSignMontaggio		"MONT"
#define kSignOperatore		"OPER"
#define kSignFotografia		"FOTO"
#define kSignEffSpeciali	"ESPE"
#define kSignTrucco			"TRUC"
#define kSignScenografia	"SCNF"
#define kSignCostumi		"COST"
#define kSignMusica			"MUSI"
#define kSignTecnSuono		"TSUO"
#define kSignVoceNarrante	"VOCE"
#define kSignDirDoppiaggio	"DOPP"
#define kSignProduttore		"PROD"
#define kSignProdEsecutivo	"PROE"
#define kSignProdAssociato	"PROA"
#define kSignDirProduzione	"DIRP"
#define kSignCast			"CAST"
#define kSignRedattore		"REDA"

// database
#define kNumeroDB		2
#define kDBFilmName		"Film"
#define kDBCodiciName	"Codici"
#define kDBFilm			0
#define kDBCodici		1


// nomi tabelle DB film
#define kTabFilm			"Film!Film_table"
#define kTabFilmNuovi		"Film!NuoviFilm"
#define kTabKeyTitolo		"KeyTitolo"
#define kTabKeyTitoloOrig	"KeyTitoloOrig"
#define kTabKeySottotitolo	"KeySottotitolo"

// nomi tabelle comuni
#define kTabColore			"Colore"
#define kTabFormato			"Formato"
#define kTabGenere			"Genere"
#define kTabNazioni			"Nazioni"
#define kTabPersone			"Personaggi"
#define kTabSuono			"Suono"
#define kTabTipo			"Tipo"


#define	kSorrisiName		"Sorrisi"
#define	kGuidaTVName		"GuidaTV"
#define	kTelePiuName		"TelePiu"

#define	kSorrisiCode		1
#define	kGuidaTVCode		2
#define	kTelePiuCode		3

#define	kPrefPrivati		"Privata"
#define	kPrefNuoviPrivati	"NuovaPriv"

enum {
	kErrInizializzazione = 101L, kErrControllo, kErrMemoria, kErrCodifica, kErrServer,
	kErrInterno, kErrRisorse, kErrXPress
	};	// codici errore

#define kErrorAlertID		30129
#define kCursoreID			21527		/* 'acur' */
#define kStrConnessioneID	20128		/* 'STR#' dati connessione (file prefs) */
#define kMenuStiliID		10130		/* 'MENU' stili presenti (file stili) */
#define	kMenuItemID			20000		/* 'STR#' voce menu per il bulb */
#define	kMenuItemNo			1
#define kpopUpFormattazione	10130
#define kStrStileCorrente	20130		/* 'STR ' voce del menu stili corrente (file prefs) */
#define kStrLastQuery		20131		/* 'STR ' ultima query effettuata (file prefs) */
#define kStrNomeCorrente	20132		/* 'STR ' nome user (file prefs) */

#define	kResParametriUtente	30128		/* 'STR#' parametri separatore e stringa indicatori */
#define	kPUtSeparatore		1			/* indice separatore */
#define	kPUtIndicatori		2			/* indice stringa indicatori */
#define	kPUtFontName		3			/* indice fontname indicatori */
#define kElencoTestateRes	30129		/* 'STR#' elenco testate da controllare */

#define	kSignatureStili			'fsty'

#define kMaxFilmVisualizzati	40L

#define	kActive					0
#define	kInactive				255

#define	kCodAzioneInsert		1
#define	kCodAzioneUpdate		2
#define	kCodAzioneDelete		3

#define	kStatoControlloNOK		0
#define	kStatoControlloBusy		1
#define	kStatoControlloOK		2

#define kStrBN					"B/N"

/*****	Typedef globali			*****/
typedef struct
{
	Str255	titolo;
	Str255	regia;
	Str255	annoProd;	// questi tre campi devono essere per primi, ed in quest'ordine !!! (vedi Leggi_Film_v02 o successive)
	long	codice;
	short	puntata;
} DescrTitolo, *PtrDescrTitolo, **HdlDescrTitolo;

typedef struct
{
	Str255	titolo;
	Str255	regia;
	Str255	annoProd;	// questi tre campi devono essere per primi, ed in quest'ordine !!! (vedi Leggi_Film_v02 o successive)
	long	codice;
	short	puntata;
	short	statoControllo;
	short	codAzione;
} DescrNuovoTitolo, *PtrDescrNuovoTitolo, **HdlDescrNuovoTitolo;

typedef struct
{
	char	nome[256];
	char	cognome[256];
	char	ruolo[5];
} DescrPersone, *PtrDescrPersone, **HdlDescrPersone;

typedef struct
{
	long			codice;
	Str255			titolo;
	Str255			codTitolo;
	Str255			titoloOrig;
	Str255			sottotitolo;
	Str255			codSottotitolo;
	Str255			tipo;
	Str255			nazione;
	Str255			annoProd;
	Str255			annoDistr;
	Str255			regia;
	Str255			aiutoRegia;
	Str255			fonteSogg;
	Str255			soggetto;
	Str255			scenegg;
	Str255			dialoghi;
	Str255			montaggio;
	Str255			operatore;
	Str255			fotografia;
	Str255			effSpeciali;
	Str255			trucco;
	Str255			scenografia;
	Str255			costumi;
	Str255			musica;
	Handle			canzoni;
	Str255			suono;
	Str255			tecnSuono;
	Str255			voceNarrante;
	Str255			dirDoppiaggio;
	Str255			durata;
	Str255			formato;
	Str255			colore;
	Str255			produttore;
	Str255			produzione;
	Str255			prodEsecutivo;
	Str255			prodAssociato;
	Str255			dirProduzione;
	Handle			cast;
	Handle			trama;
	Str255			divieti;
	Handle			premi;
	Handle			note;
	Str255			genere;
	Str255			sottogenere;
	Str255			giudizio;
	Handle			tramaSC;
	Handle			tramaBreveSC;
	Str255			redattore;
	Str255			userID;
	Str255			dataIns;
	Str255			puntata;
// per indicizzazioni
	Handle			idxTitolo;
	Handle			idxTitoloOrig;
	Handle			idxNazione;
	HdlDescrPersone	idxPersone;
	Handle			idxColore;
	Handle			idxFormato;
	Handle			idxGenere;
	Handle			idxSuono;
	Handle			idxTipo;
	Handle			idxSottotitolo;

// qui i dati riempiti dall' utente
	Handle			datiProgrammazione;			// il campo "Altre informazioni"
	Str255 			ora;						// l'ora
	Str255			ciclo;						// il ciclo
	Str255			indicatori;
	Str255			sottotitolato;
	short 			primaVis;					// per ora accetta solo valori 0 e 1
	Handle			commento;
	short 			codBambini;					// non usata
	short			grigliaScelta;				// non usata
	Str255			grigliaStr;					// non usata
	Handle			tramaCorrente;				// la trama corrente (copia di un puntatore)

// qui i dati specifici della tabella nuovifilm
	short			statoControllo;
	short			codAzione;
	Str255			testata;
} DescrFilm, *PtrDescrFilm, **HdlDescrFilm;
