/*** File: "memoryHandle.h"
 *
 *	Use the function calloc to simulate the
 *	data type Handle.
 *
 *	First version 24 feb 96
 *
 ****/
#ifndef __MEMORYHANDLE__
#define __MEMORYHANDLE__
#include "macintoshUtil.h"

#ifndef __MACINTOSH__
#include <stdlib.h>

typedef struct HandleData
{
	char *ptr;
	int	 size;
	int  memorySize;
};
typedef HandleData *Handle;
typedef char *Ptr;
enum OSErr {noErr = 0, dsMemFullErr = 25, dsBusError = 1};

/*** Define a new Handle of dimension 'size'
 *
 ***/
Handle NewHandle(longint size);

/*** Define a new Ptr of dimension 'size'
 *
 ***/
Ptr NewPtr(longint size);

/*** get the handle size.
 *
 ***/
longint GetHandleSize(Handle theHandle);

/*** Redefine the dimension of the Handle copying old data.
 *
 ***/
void SetHandleSize (Handle theHandle, longint size);

/*** Dispose a handle.
 *
 ***/
DisposHandle(theHandle);

/*** Error code
 *
 ***/
OSErr MemError(void);
#else
#include <Memory.h>
#endif
#endif