/*** File: "stringUtility_v01.h"
*
*	Versione 00. On 10-09-94.
*	Scritto da Cadili Francesco.
*
*	Trasferimenti di stringhe.
********************************************/
#ifndef __stringUtility__
#define __stringUtility__
#include <Types.h>

/*** Procedura: "copyPascalStr(strRead, strWrite)"
*
*	Copia "strRead" in "strWrite".
*	Le stringhe sono "pascal string".
*
*	Par INPUT:	'strRead' la stringa letta.
*	Par OUTPUT:	'strWrite' la copia di 'strRead'.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyPascalStr(unsigned char *strRead, unsigned char *strWrite);

/*** Procedura: "copyPascaltoCHandle(strRead, &hdl)"
*
*	Copia "strRead" in "strWrite".
*
*	Par INPUT:	'strRead' la stringa pascal letta.
*	Par OUTPUT:	'hdl' l'handle.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyPascaltoCHandle(unsigned char *strRead, Handle *hdl);

/*** Procedura: "copyCtoCHandle(strRead, &hdl)"
*
*	Copia "strRead" in "strWrite".
*
*	Par INPUT:	'strRead' la stringa pascal letta.
*	Par OUTPUT:	'hdl' l'handle.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyCtoCHandle(char *strRead, Handle *hdl);

/*** Procedura: "copyHandleCtoHandle(strRead, &hdl)"
*
*	Copia un Handle a una stringa C in un Handle.
*
*	Par INPUT:	'strRead' la stringa letta.
*	Par OUTPUT:	'hdl' la copia di 'strRead'.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyHandleCtoHandleC(char **strRead, Handle *hdl);

/*** Procedura: "copyHandletoCHandle(strRead, len, &hdl)"
*
*	Copia "strRead" in "strWrite".
*
*	Par INPUT:	'strRead' la stringa pascal letta,
*				'len' la sua lunghezza.
*	Par OUTPUT:	'hdl' l'handle.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyHandletoCHandle(Handle strRead, long len, Handle *hdl);

/*** Procedura: "copyHandletoPascal(strRead, len, strWrite)"
*
*	Copia "strRead" in "strWrite".
*
*	Par INPUT:	'strRead' la stringa pascal letta,
*				'len' la sua lunghezza.
*	Par OUTPUT:	'strWrite' la stringa pascal.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int copyHandletoPascal(Handle strRead, long len, unsigned char *strWrite);

/*** Procedura: "compareCHandleToPascal(strRead, pascalStr)"
*
*	Confronta un handle a una stringa C con una stringa pascal.
*
*	Par INPUT:	'strRead' l'handle alla stringa C.
*	Par OUTPUT:	'pascalStr' la stringa pascal da controntare.
*	Val OUTPUT:	FALSE se errore, TRUE altrimenti.
*************************************************************************/
int compareCHandleToPascal(char **strRead, unsigned char *pascalStr);

/*** concatStr(strWrite, strRead)
*
*	Concatena strWrite a strRead
*
*	Par INPUT:	'strWrite' la stringa su cui scrivo.
*				'strRead' la stringa da concatenare.
*	Par OUTPUT:	'strWrite' la stringa con l'aggiunta.
*	Val OUTPUT:	TRUE se ha potuto concatenare, FALSE altrimenti.
*
********************************************************************/
int concatStr(unsigned char *strWrite, unsigned char *strRead);

/*** copyChars(strRead, inizio, nChar, strWrite, &pos)
*
*	Concatena strWrite a strRead
*
*	Par INPUT:	'strRead' la stringa letta,
*				'inizio' la posizione del primo carattere,
*				'nChar' il numero di caratteri da leggere,
*				'strWrite' la stringa su cui scrivo,
*				'pos' la posizione del primo carattere.
*	Par OUTPUT:	'pos' punta al prossimo carattere da scrivere.
*
********************************************************************/
void copyChars(char *strRead, long inizio, long nChar, char *strWrite, long *pos);

/*** GetLength(cStrHdl)
*
*	Determina la lunghezza di un Handle ad una stringa C.
*
*	Par INPUT:	'cStrHdl' puntatore allo Handle di una C string.
*******************************************************************/
long GetLength(Handle cStrHdl);

/****
 *	formattaRegia_Cast(stringa1, stringa2)
 *
 *	formatta la stinga1. Aggiunge alla fine
 *	di ogni riga un punto.
 *
 ****************************************************/
long formattaRegia_Cast(char *stringa1, char *stringa2);

/****
 *	calcolaRet(cStrHdl)
 *
 *	l'handle alla stringa C.
 *
 ****/
long calcolaRet(Handle cStrHdl);

/****
 *	formattaCHandle(cStrHdl, &formattato)
 *
 *	formatta l'Handle alla stringa.
 *	inserisce un punto prima di ogni '\r'.
 *
 ****/
short formattaCHandle(Handle cStrHdl, Handle *formattato);
#endif